<?php
// $Id: cmsns.pager.inc,v 1.1 2008/11/30 06:46:31 eastcn Exp $

function cmsns_xiaoxi_page_view($ac){
  if(!$_GET['his']){
    $result = pager_query('SELECT * FROM {x_xiaoxi} WHERE touid = %d OR uid = %d ORDER BY id DESC', 20, 0, null, $ac->uid, $ac->uid);
    drupal_set_title(t('我的信件往来记录'));
  }elseif(is_numeric($_GET['his'])){
    $result = pager_query('SELECT * FROM {x_xiaoxi} WHERE touid IN (%d, %d) OR uid IN (%d, %d) ORDER BY id DESC', 20, 0, null, $ac->uid, $_GET['his'], $_GET['his'], $ac->uid);
    $tu = $u = _cmsns_qianbao_user(array('uid' => $_GET['his']));
    drupal_set_title(t('我和!u的信件往来记录', array('!u' => $tu->name)));
  }
  $i = 0;
  while ($a = db_fetch_object($result)){
    if(!$_GET['his']){
      $u = _cmsns_qianbao_user(array('uid' => $a->touid));
      $tu = _cmsns_qianbao_user(array('uid' => $a->uid));
    }
    if($a->touid == $ac->uid){
      $loc = t('!u 寄给我', array('!u' => theme('cmsns_username', $tu)));
      $gourl = "user/$ac->uid/xiaoxi/get/$a->uid";
      if($a->tostatus == 1){
        $s = '<span class="f00">'.t('尚未阅读').'</span>';
      }else{
        $s = t('已经阅读');
      }
    }else{
      $loc = t('我寄给 !u', array('!u' => theme('cmsns_username', $u)));
      $gourl = "user/$ac->uid/xiaoxi/set/$a->uid";
      if($a->tostatus == 1){
        $s = '<span class="f00">'.t('对方尚未阅读').'</span>';
      }else{
        $s = t('对方已经阅读');
      }
    }
    $rows[] = array($loc, l(check_plain($a->title), $gourl, array('fragment' => "msg-$a->id", 'query' => array('msg' => $a->id))), t('%t之前', array('%t' => format_interval(time() - $a->atime))), $s);
    $i = true;
  }
  if($i){
    $v = theme('table', array(t('至'), t('信件主题'), t('来信时间'), t('信件状态')), $rows, array('id' => 'xiaoxibox'));
    $v .= theme('pager', NULL, 20, 0);
  }else{
    $v = t('没有任何信件');
  }
  $v .= '<h2>'.t('写信').'</h2>'.drupal_get_form('cmsns_xiaoxi_msg_form');
  return $v;
}

function cmsns_xiaoxi_page_set($ac){
  global $user;
  if(!is_numeric(arg(4))){
    $result = pager_query('SELECT id, touid, tostatus, atime, title FROM {x_xiaoxi} WHERE uid = '.$user->uid . ' AND status = 1 ORDER BY tostatus ASC, atime DESC', 20, 0);
    $true = false;
    while ($a = db_fetch_object($result)){
      $u = _cmsns_qianbao_user(array('uid' => $a->touid));
      if($a->tostatus == 1){
        $s = '<span class="f00">'.t('对方尚未阅读').'</span>';
      }else{
        $s = t('对方已经阅读');
      }
      $t[$a->id] = array('title' => l(check_plain($a->title), "user/$user->uid/xiaoxi/set/$a->id"), 'id' => $a->id, 'name' => theme('cmsns_username', $u), 'time' => t('%t之前', array('%t' => format_interval(time() - $a->atime))), 's' => $s);
      $true = true;
    }
    if($true){
      $v = drupal_get_form('cmsns_xiaoxi_msg_lists', $t, 'set');
      $v .= theme('pager', NULL, 20, 0);
    }else{
      $v = '<h2>'.t('发件箱是空的。').'</h2>';
    }
    $v .= '<h2>'.t('写信').'</h2>'.drupal_get_form('cmsns_xiaoxi_msg_form');
    drupal_set_title(t('发件箱'));
  }else{
    $id = arg(4);
    $result = db_query('SELECT x.*, b.body FROM {x_xiaoxi} x INNER JOIN {x_xiaoxi_body} b ON x.xid = b.xid WHERE x.id = '.$id. ' = 1 AND x.uid = '.$user->uid);
    $true = false;
    while ($a = db_fetch_object($result)){
      if($a->status == 1){
        $ut = _cmsns_qianbao_user(array('uid' => $a->touid));
        $value['name'] = $ut->name;
        if($a->tostatus == 1){
          $s = '<span class="f00">'.t('对方尚未阅读').'</span>';
        }else{
          $s = t('对方已经阅读');
        }
        $rows[] = '<span class="msg-title">'.t('主题：').'</span>'.check_plain($a->title);
        $rows[] = '<span class="msg-title">'.t('寄给：').'</span>'.theme('cmsns_username',$ut).' ('.l(t('查看全部往来信件'), "user/$ac->uid/xiaoxi", array('query' => array('his' => $a->touid))).')';
        $rows[] = '<span class="msg-title">'.t('时间：').'</span>'.format_date($a->atime,'small');
        $rows[] = '<span class="msg-title">'.t('正文：').'</span><div class="msg-body">'.check_markup($a->body, 0, FALSE).'</div>';
        drupal_set_title(t('发件箱 @title', array('@title' => check_plain($a->title))));
      }else{
        return '<h2>'.t('这封信件已经被你删除。').'</h2>';
      }
      $true = true;
    }
    if($true){
      $v = theme('item_list',$rows);
      $v .= '<h2>'.t('再给!name写一封信', array('!name' => $ut->name)).'</h2>'.drupal_get_form('cmsns_xiaoxi_msg_form',$value);
    }else{
      $v = '<h2>'.t('非法访问。').'</h2>';
    }
  }
  return $v;
}

function cmsns_xiaoxi_page_get($ac){
  if(is_numeric(arg(4))){
    $a = db_fetch_object(db_query('SELECT x.*, b.body FROM {x_xiaoxi} x INNER JOIN {x_xiaoxi_body} b ON x.xid = b.xid WHERE x.id = %d AND x.touid = %d', arg(4), $ac->uid));
    if($a->uid){
      if($a->tostatus != 0){
        $ut = _cmsns_qianbao_user(array('uid' => $a->uid));
        $value['name'] = $ut->name;
        $rows[] = '<span class="msg-title">'.t('主题：').'</span>'.check_plain($a->title);
        $rows[] = '<span class="msg-title">'.t('来自：').'</span>'.theme('cmsns_username',$ut).' ('.l(t('查看全部往来信件'), "user/$ac->uid/xiaoxi", array('query' => array('his' => $a->uid))).')';
        if($a->tostatus == 1){
          db_query("UPDATE {x_xiaoxi} SET tostatus = 2 WHERE id = %d", $a->id);
        }
        $rows[] = '<span class="msg-title">'.t('时间：').'</span>'.format_date($a->atime,'small');
        $rows[] = '<span class="msg-title">'.t('正文：').'</span><div class="msg-body">'.check_markup($a->body, 0, FALSE).'</div>';
        $value['title'] = t('回复：').$a->title;
        $v = theme('item_list', $rows);
        $v .= '<h2>'.t('给!name回信',array('!name' => $ut->name)).'</h2>'.drupal_get_form('cmsns_xiaoxi_msg_form',$value);
        drupal_set_title(t('收件箱 @title', array('@title' => check_plain($a->title))));
      }else{
       return '<h2>'.t('这封信件已经被你删除。').'</h2>';
      }
    }else{
      return '<h2>'.t('非法访问。').'</h2>';
    }
  }else{
    $result = pager_query('SELECT uid, id, touid, tostatus, atime, title FROM {x_xiaoxi} WHERE touid = '.$ac->uid . ' AND status = 1 ORDER BY tostatus ASC, atime DESC', 20, 0);
    $true = false;
    while ($a = db_fetch_object($result)){
      $u = _cmsns_qianbao_user(array('uid' => $a->uid));
      if($a->tostatus == 1){
        $s = '<span class="f00">'.t('尚未阅读').'</span>';
      }else{
        $s = t('已经阅读');
      }
      $t[$a->id] = array('title' => l(check_plain($a->title), "user/$ac->uid/xiaoxi/get/$a->id"), 'id' => $a->id, 'name' => theme('cmsns_username', $u), 'time' => t('%t之前', array('%t' => format_interval(time() - $a->atime))), 's' => $s);
      $true = true;
    }
    if($true){
      $v = drupal_get_form('cmsns_xiaoxi_msg_lists', $t, 'set');
      $v .= theme('pager', NULL, 20, 0);
    }else{
      $v = '<h2>'.t('收件箱是空的。').'</h2>';
    }
    $v .= '<h2>'.t('写信').'</h2>'.drupal_get_form('cmsns_xiaoxi_msg_form');
    drupal_set_title(t('收件箱'));
  }
  return $v;
}

function cmsns_xiaoxi_page_sys($ac){
  global $user;
  $result = pager_query('SELECT * FROM {x_xiaoxi_body} WHERE status = 2 ORDER BY xid ASC', 50, 0);
  $true = false;
  switch (arg(4)){
    case 'view':
      $i = 1; 
      while ($a = db_fetch_object($result)){
        $u = _cmsns_qianbao_user(array('uid' => $a->uid));
        $rows[] = '<span id="sys-'.$a->xid.'" class="xiaoxititle">'.$i.'</span>'.t('!n 于 %t(%i之前)发布了这条公告：', array('!n' => theme('cmsns_username', $u), '%t' => format_date($a->ctime,'small'), '%i' => format_interval(time() - $a->ctime))).'<div class="system-title"><span class="system-t">'.t('主题：').'</span>'.$a->title.'</div><div class="system-body"><div class="system-z">'.t('正文：').'</div>'.check_markup($a->body, 0, FALSE).'</div>';
        $i++;
      }
      if($i){
        $v = theme('item_list', $rows);
      }else{
        $v = '<h2>'.t('非法访问。').'</h2>';
      }
    break;
    case 'edit':
      $result = db_query('SELECT * FROM {x_xiaoxi_body} WHERE xid = %d AND  status = 2', arg(5));
      $true = false;
      while ($a = db_fetch_object($result)){
        $c['title'] = $a->title;
        $c['body'] = $a->body;
        $c['xid'] = $a->xid;
        $true = true;
      }
      if($true && user_access('create notice')){
        $c['type'] = 'edit';
        $v .= '<h2>'.t('编辑系统公告').'</h2>'.drupal_get_form('cmsns_xiaoxi_msg_sys_form',$c);
      }else{
        $v = '<h2>'.t('非法访问。').'</h2>';
      }
    break;
    default:
      $result = pager_query('SELECT * FROM {x_xiaoxi_body} WHERE status = 2 ORDER BY xid DESC', 50, 0);
      while ($a = db_fetch_object($result)){
        $u = _cmsns_qianbao_user(array('uid' => $a->uid));
        if(!user_access('create notice')){
          $rows[] = array(theme('username', $u), l($a->title,"user/$user->uid/xiaoxi/sys/view", array('fragment' => "sys-$a->xid")), format_interval(time() - $a->ctime));
        }else{
          $t[$a->xid] = array('title' => l($a->title, "user/$user->uid/xiaoxi/sys/view", array('fragment' => "sys-$a->xid")), 'id' => $a->xid, 'name' => theme('username', $u), 'time' => t('%t之前', array('%t' => format_interval(time() - $a->ctime))), 's' => l(t('编辑'),"user/$user->uid/xiaoxi/sys/edit/$a->xid", array('query' => drupal_get_destination())));
        }
        $true = true;
      }
      if($true){
        if($user->uid == 1 || user_access('create notice')){
          $v = drupal_get_form('cmsns_xiaoxi_msg_lists', $t, 'sys');
          $v .= '<h2>'.t('发布系统消息').'</h2>'.drupal_get_form('cmsns_xiaoxi_msg_sys_form');
        }else{
          $v = theme('table', array(t('发布人'), t('主题'), t('发布时间')), $rows, array('id' => 'xiaoxibox'));
        }
        $v .= theme('pager', NULL, 50, 0);
      }else{
        $v = '<h2>'.t('没有系统消息。').'</h2>';
        if($user->uid == 1 || user_access('create notice')){
          $v .= '<h2>'.t('发布系统消息').'</h2>'.drupal_get_form('cmsns_xiaoxi_msg_sys_form');
        }
      }
    break;
  }
  drupal_set_title(t('系统公告'));
  return $v;
}

function cmsns_xiaoxi_page_edit($ac){
  global $user;
  if(!is_numeric(arg(4))){
    $result = pager_query('SELECT * FROM {x_xiaoxi_body} WHERE uid = '.$user->uid.' AND status = 0 ORDER BY xid DESC', 20, 0);
    $true = false;
    while ($a = db_fetch_object($result)){
      $t[$a->xid] = array('title' => l(check_plain($a->title),"user/$user->uid/xiaoxi/edit/$a->xid", array('query' => drupal_get_destination())), 'id' => $a->xid, 'time' => t('%t之前', array('%t' => format_interval(time() - $a->ctime))), 's' => l(t('编辑'), "user/$user->uid/xiaoxi/edit/$a->xid", array('query' => drupal_get_destination())));
      $true = true;
    }
    if($true){
      $v = drupal_get_form('cmsns_xiaoxi_msg_lists', $t, 'edit');
      $v .= theme('pager', NULL, 20, 0);
    }else{
      $v = '<h2>'.t('草稿箱是空的').'</h2>';
    }
    $v .= '<h2>'.t('写信').'</h2>'.drupal_get_form('cmsns_xiaoxi_msg_form');
    drupal_set_title(t('草稿箱'));
  }else{
    $result = db_query('SELECT * FROM {x_xiaoxi_body} WHERE xid = %d AND uid = %d AND status = 0', arg(4), $user->uid);
    $true = false;
    while ($a = db_fetch_object($result)){
      $c['title'] = $a->title;
      $c['body'] = $a->body;
      $c['xid'] = $a->xid;
      $true = true;
    }
    if($true){
      $c['type'] = 'edit';
      $v .= '<h2>'.t('编辑草稿').'</h2>'.drupal_get_form('cmsns_xiaoxi_msg_form',$c);
    }else{
      $v = '<h2>'.t('非法访问。').'</h2>';
    }
    drupal_set_title(t('编辑草稿'));
  }
  return $v;
}

function cmsns_xiaoxi_msg_lists(& $form_state, $value, $type){
  foreach ($value as $key => $x){
    $form['new'][$key]['del'] = array('#type' => 'checkbox');
    $form['new'][$key]['name'] = array('#value' => $x['name']);
    $form['new'][$key]['title'] = array('#value' => $x['title']);
    $form['new'][$key]['time'] = array('#value' => $x['time']);
    $form['new'][$key]['s'] = array('#value' => $x['s']);
    $form['new'][$key]['t'] = array('#type' => 'value', '#value' => $x['title']);
  }
  $form['type'] = array('#type' => 'value', '#value' => $type);
  $form['new']['#tree'] = true;
  $form['new']['#theme'] = 'cmsns_xiaoxi_msg_lists_table';
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('确认删除选中消息'),
    '#submit' => array('cmsns_xiaoxi_msg_lists_submit'),
  );
  return $form;
}

function cmsns_xiaoxi_msg_lists_submit($form, & $form_state) {
	global $user;
	foreach($form_state['values']['new'] as $id => $key) {
		if ($key['del'] == 1) {
      if(cmsns_xiaoxi_msg_del(array('id' => $id, 'type' => $form_state['values']['type']))){
			  drupal_set_message(t('信件 !t 已成功从你的信箱中移除', array('!t' => $key['t'])));
      }else{
        drupal_set_message(t('移除 !t 失败', array('!t' =>$key['t'])));
      }
		}
	}
}

function theme_cmsns_xiaoxi_msg_lists_table($form) {
  foreach (element_children($form) as $key) {
    $row = array();
    $row[] = drupal_render($form[$key]['del']);
    if(arg(3) != 'edit'){
      $row[] = drupal_render($form[$key]['name']);
    }
    $row[] = drupal_render($form[$key]['title']);
    $row[] = drupal_render($form[$key]['time']);
    $row[] = drupal_render($form[$key]['s']);
    $rows[] = $row;
  }
  switch (arg(3)){
    case 'set':
      $header = array(t('删除'), t('寄至'),t('主题'),t('时间'), t('状态'));
    break;
    case 'get':
      $header = array(t('删除'), t('来自'),t('主题'),t('时间'), t('状态'));
    break;
    case 'edit':
      $header = array(t('删除'), t('主题'),t('创建时间'), t('编辑'));
    break;
    case 'sys':
      $header = array(t('删除'), t('发布人'),t('主题'),t('发布时间'), t('编辑'));
    break;
  }
  $t = theme('table', $header, $rows, array('id'=>'xiaoxibox'));
  return $t;
}

function cmsns_xiaoxi_msg_sys_form(& $form_state, $v = false){
  global $user;
	$form['title'] = array(
    '#type'=> 'textfield',
    '#title' => t('主题'),
    '#default_value' => $v['title'],
    '#size'  => 80,
    '#required' => TRUE,
    '#maxlength' => 128,
	);
  $form['body'] = array(
    '#type' => 'textarea',
    '#title' => t('内容'),
    '#default_value' => $v['body'],
    '#required' => TRUE,
    '#cols' => 40,
    '#rows' => 10
  );
  
  $form['v'] = array(
  	'#type' => 'value',
  	'#value' => $v,
  );
  
  $form['submit'] = array(
  	'#type' => 'submit',
  	'#value' => t('写好了，确认发布'),
  	'#submit' => array('cmsns_xiaoxi_msg_sys_form_submit'),
  );
  $form['#validate'][] = 'cmsns_xiaoxi_msg_sys_form_validate';
  return $form;
}

function cmsns_xiaoxi_msg_sys_form_validate($form, & $form_state) {
  global $user;
  if($form_state['values']['title'] == '' && $form_state['values']['body'] == '' ){
    form_set_error('title', t('标题和正文不能为空。'));
  }
}

function cmsns_xiaoxi_msg_sys_form_submit($form, & $form_state) {
  global $user;
  $v = $form_state['values']['v'];
  cmsns_xiaoxi_msg_set(array('status' => 2,'title' => $form_state['values']['title'], 'body' => $form_state['values']['body'],  'type' => $v['type'], 'xid' => $v['xid']));
}

function cmsns_page_privacy(& $form_state, $ac){
	$u = cmsns_privacy($ac->uid);
	$form['xiaoxi'] = array(
		'#type' => 'fieldset',
		'#title' => t('信箱设置'),
		'#collapsible' => TRUE,
		'#collapsed' => FALSE,
		'#attributes' => array('class' => 'menu-item-form'),
	);
	$form['xiaoxi']['x'] = array(
		'#type' => 'radios',
		'#title' => t('隐私选项'),
		'#default_value' => $u->xiaoxi ? $u->xiaoxi: 0,
		'#options' => array(
      t('只接受好友的消息'), 
      t('接受任何人的消息'),
      t('不接受任何人的消息'), 
    ),
	);
	$form['haoyou'] = array(
		'#type' => 'fieldset',
		'#title' => t('好友设置'),
		'#collapsible' => TRUE,
		'#collapsed' => FALSE,
		'#attributes' => array('class' => 'menu-item-form'),
	);
	$form['haoyou']['h'] = array(
		'#type' => 'radios',
		'#title' => t('隐私选项'),
		'#default_value' => $u->haoyou ? $u->haoyou: 0,
		'#options' => array(
     t('加为好友需要验证'), 
     t('加为好友不需要验证'),
     t('不允许加我为好友'), 
    ),
	);
	$form['qianbao'] = array(
		'#type' => 'fieldset',
		'#title' => t('钱包设置'),
		'#collapsible' => TRUE,
		'#collapsed' => FALSE,
		'#attributes' => array('class' => 'menu-item-form'),
	);
	$form['qianbao']['q'] = array(
		'#type' => 'radios',
		'#title' => t('隐私选项'),
		'#default_value' => $u->qianbao ? $u->qianbao: 0,
		'#options' => array(
      t('不允许任何人查看我的财务概况'),
      t('允许好友查看我的财务概况'),
      t('允许所有用户查看我的财务概况'),
    ),
    '#disabled' => true
	);
  $form['v'] = array(
  	'#type' => 'value',
  	'#value' => $u->uid,
  );
  
  $form['submit'] = array(
  	'#type' => 'submit',
  	'#value' => t('确认设定'),
  	'#submit' => array('cmsns_page_privacy_submit'),
  );
  return $form;
}

function cmsns_page_privacy_submit($form, & $form_state) {
  global $user;
  $v = $form_state['values'];
  if($v['v']){
    db_query("UPDATE {x_qianbao_sum} SET xiaoxi = %d, haoyou = %d, qianbao = %d WHERE uid = %d", $v['x'], $v['h'], $v['q'], $user->uid);
    $t = true;
  }else{
    db_query("INSERT INTO {x_qianbao_sum} (uid, sum, qianbao, xiaoxi, haoyou) VALUES ( %d, %d, %d, %d, %d)",$user->uid, $v['q'], $v['x'], $v['h']);
    $t = true;
  }
  if($t){
    $msg = t('隐私选项更新成功。');
  }else{
    $msg = t('抱歉，发生了未知问题，更新失败。');
  }
  drupal_set_message($msg);
}

function cmsns_haoyou_page_view($ac){
  global $user;
  $v = '';
  if(arg(3) == 'action'){
    if(arg(4) != 'g' && is_numeric(arg(5))){
      $b = db_fetch_object(db_query('SELECT * FROM {x_haoyou_to} WHERE uid = %d AND touid = %d', $user->uid, arg(5)));
      if($b->uid){
        $to = _cmsns_qianbao_user(array('uid' => $b->touid));
        $value = array('uid' => $user->uid, 'touid' => $b->touid, 'name' => $to->name);
      }
    }
    switch (arg(4)){
      case 'bei':
        $c = drupal_get_form('cmsns_haoyou_page_action_bei', $value);
      break;
      case 'del':
        if(!$_GET['del']){
          $c = t('确认删除好友：!n', array('!n' => $to->name)). l(t('确认'), $_GET['q'], array('query' => array('del' => 'ok'), 'attributes' => array('class' => 'haoyou_del_ok')));
        }else{
          cmsns_haoyou_info_del($value);
          drupal_goto("user/$user->uid/haoyou");
        }
      break;
      case 'move':
        if($bb = _cmsns_haoyou_user_gid()){
          $value['gid'] = $bb;
          $c = drupal_get_form('cmsns_haoyou_page_action_move', $value);
        }else{
          drupal_set_message(t('请先添加一个好友分组。'));
          drupal_goto("user/$user->uid/haoyou/action/g");
        }
      break;
      case 'ban':
        if(!$_GET['ban']){
          $c = t('确认删除好友 !n 并将其加入黑名单：', array('!n' => $to->name)).l('确认', $_GET['q'], array('query' => array('ban' => 'ok'), 'attributes' => array('class' => 'haoyou_del_ok')));
        }else{
          cmsns_haoyou_info_ban($value);
          drupal_goto("user/$user->uid/haoyou");
        }
      break;
      case 'removeban':
        if(!$_GET['removeban']){
          $c = l(t('确认从黑名单移除：'), $_GET['q'], array('query' => array('removeban' => 'ok'))). $to->name;
        }else{
          haoyou_info_removeban($value);
          drupal_goto("user/$user->uid/haoyou");
        }
      break;
      case 'g':
        $c = drupal_get_form('cmsns_haoyou_page_action_g');
      break;
      default:
        drupal_goto("user/$user->uid/haoyou");
      break;
    }
  }
  if($c){
    $cc = '<div class="haoyou_action">'.$c.'</div>';
  }
  $result = db_query('SELECT * FROM {x_haoyou} WHERE uid = 0 OR uid = %d ORDER BY id DESC',$user->uid);
  while ($a = db_fetch_object($result)){
    if($a->id > 2){
      $editname = l(t('Revised'), "user/$user->uid/haoyou/action/g/$a->id");
    }else{
      $editname = false;
    }
    $t[] = array('data' => '<div class="haoyou_gid_title"><span class="haoyou_gid_name">'.$a->name . '</span>' . $editname. '</div>'. _cmsns_haoyou_page_view_sql($user->uid, $a->id));
  }
  $v = '<table id="haoyou_view"><tr valign="top"><td width=200>'.theme('item_list', $t, l(t('Add a new group'), "user/$user->uid/haoyou/action/g", array('attributes' => array('class' => 'haoyouiframe'))), 'ul', array('class' => 'haoyou_list')).'</td>';
  $v .= '<td>'. $cc .drupal_get_form('cmsns_haoyou_add_form') .'</td></tr></table>';
  drupal_set_message($msg);
  return $v;
}

function _cmsns_haoyou_page_view_sql($uid, $id){
  global $user;
  $result = db_query('SELECT h.msg, h.gid, u.name, u.access, u.uid FROM {x_haoyou_to} h INNER JOIN {users} u ON h.touid = u.uid WHERE h.uid = %d AND h.gid = %d ORDER BY h.gid DESC, u.access DESC', $uid, $id);
  while ($a = db_fetch_object($result)){
    $b = _cmsns_username_info($a, $a, 1);
    $t[] = $b;
  }
  return theme('item_list', $t);
}

function cmsns_haoyou_page_action_bei(&$form_state, $value){
  $form['name'] = array(
    '#type' => 'textfield',
    '#title' => t('备注好友 !n', array('!n' => $value['name'])),
    '#size' => 30,
    '#description' => t('最大长度60个字符'),
    '#prefix' => '<div id="haoyou_page_action_name">',
    '#suffix' => '</div>',
    );
  $form['submit'] = array(
  	'#type' => 'submit',
  	'#value' => t('确认'),
    '#submit' => array('haoyou_page_action_submit'),
    '#prefix' => '<div id="haoyou_page_action_submit">',
    '#suffix' => '</div>',
  );
  $form['value'] = array(
  	'#type' => 'value',
  	'#value' => $value,
  );
  $form['#validate'][] = 'haoyou_page_action_bei_validate';
  return $form;
}

function cmsns_haoyou_page_action_bei_validate($form, & $form_state) {
  if(drupal_strlen($form_state['values']['name']) > 60){
    form_set_error('name', t('备注过长。请重新输入'));
  }else{
    $v = $form_state['values']['value'];
    if(db_query("UPDATE {x_haoyou_to} SET msg = '%s' WHERE touid = %d AND uid = %d", $form_state['values']['name'], $v['touid'], $v['uid'])){
      drupal_set_message(t('操作成功'));
    }
  }
}

function cmsns_haoyou_page_action_g(&$form_state){
  global $user;
  if(is_numeric(arg(5))){
    $name = db_result(db_query('SELECT name FROM {x_haoyou} WHERE id = %d AND uid = %d', arg(5), $user->uid));
    if(!$name){
      drupal_set_message(t('非法访问'));
      drupal_goto("user/$user->uid/haoyou");
    }
    $title = t('修改组名');
  }else{
    $title = t('输入组名');
  }
  $form['name'] = array(
    '#type' => 'textfield',
    '#title' => $title,
    '#default_value' => $name ? $name: null,
    '#description' => t('最大长度24个字符'),
    '#size' => 10,
    );
  $form['submit'] = array(
  	'#type' => 'submit',
    '#submit' => array('cmsns_haoyou_page_action_submit'),
  	'#value' => t('确认'),
  );
  $form['#validate'][] = 'cmsns_haoyou_page_action_g_validate';
  return $form;
}

function cmsns_haoyou_page_action_g_validate($form, & $form_state) {
  global $user;
  if(drupal_strlen($form_state['values']['name']) > 24){
    form_set_error('name', t('组名太长。请重新输入'));
  }elseif(!is_numeric(arg(5))){
    if(db_query("INSERT INTO {x_haoyou} (uid, name) VALUES (%d, '%s')",$user->uid, $form_state['values']['name'])){
      drupal_set_message(t('分组添加成功'));
    }
  }else{
   if(db_query("UPDATE {x_haoyou} SET name = '%s' WHERE id = %d", $form_state['values']['name'], arg(5))){
      drupal_set_message(t('组名修改成功'));
    }
  }
}

function cmsns_haoyou_page_action_move(&$form_state, $value){
	$form['name'] = array(
		'#title' => t('将好友 !n 移动到', array('!n' => $value['name'])),
		'#type' => 'select',
		'#options' => $value['gid'],
		'#default_value' => $_GET['gid'],
	);
  $form['value'] = array(
  	'#type' => 'value',
  	'#value' => $value,
  );
  $form['submit'] = array(
  	'#type' => 'submit',
    '#submit' => array('cmsns_haoyou_page_action_submit'),
  	'#value' => t('确认'),
  );
  $form['#validate'][] = 'cmsns_haoyou_page_action_move_validate';
  return $form;
}
function cmsns_haoyou_page_action_submit(&$form_state, $value){
  global $user;
  drupal_goto("user/$user->uid/haoyou");
}
function cmsns_haoyou_page_action_move_validate($form, & $form_state) {
  $v = $form_state['values']['value'];
  $gid = $form_state['values']['name'];
  if($_GET['gid'] == $gid){
    return drupal_set_message(t('未做任何更改'));
  }
  if(db_query('UPDATE {x_haoyou_to} SET gid = %d WHERE touid = %d AND uid = %d', $gid, $v['touid'], $v['uid'])){
    drupal_set_message(t('操作成功'));
  }else{
    drupal_set_message(t('操作失败'));
  }
}

function cmsns_haoyou_page_info($ac){
  global $user;
  switch(arg(4)){
    case '':
      $result = pager_query('SELECT * FROM {x_haoyou_msg} WHERE type = 1 AND (uid = %d OR touid = %d) ORDER BY id DESC', 50, 0, NULL, $user->uid, $user->uid);
    break;
    case 'set':
      $result = pager_query('SELECT * FROM {x_haoyou_msg} WHERE  type = 1 AND uid = %d ORDER BY id DESC', 50, 0, NULL, $user->uid);
    break;
    case 'get':
      $result = pager_query('SELECT * FROM {x_haoyou_msg} WHERE type = 1 AND touid = %d ORDER BY sys ASC, id DESC', 50, 0, NULL, $user->uid);
    break;
  }
  $true = false;
  while ($a = db_fetch_object($result)){
    $row = array();
    $row[] = format_date($a->time,'small');
    if($a->uid == $user->uid){
      $touser = _cmsns_qianbao_user(array('uid' => $a->touid));
      $row[] = t('你申请成为 !n 的好友，附言：!msg', array('!n' => theme('username',$touser), '!msg' => $a->msg));
      switch ($a->sys){
        case '0':
          $row[] = t('等待 !n 批准', array('!n' => theme('username',$touser)));
        break;
        case '1':
          $row[] = t('已经通过');
        break;
        case '2':
          $row[] = t('!n 拒绝了', array('!n' => theme('username',$touser)));
        break;
        case '3':
          $row[] = t('你被 !n 列为黑名单', array('!n' => $touser->name));
        break;
      }
    }else{
      $touser = _cmsns_qianbao_user(array('uid' => $a->uid));
      $row[] = t('!n 申请成为你的好友，附言：!msg', array('!n' => theme('username',$touser), '!msg' => $a->msg));
      switch ($a->sys){
        case '0':
          $row[] = l(t('批准'), "user/$user->uid/haoyou/info/op/ok/$touser->uid/$a->id", array('query' => drupal_get_destination())).' | '. l(t('拒绝'),"user/$user->uid/haoyou/info/op/no/$touser->uid/$a->id", array('query' => drupal_get_destination())).' | '.l(t('永久拒绝'),"user/$user->uid/haoyou/info/op/kill/$touser->uid/$a->id", array('query' => drupal_get_destination()));
        break;
        case '1':
          $row[] = t('已经通过');
        break;
        case '2':
          $row[] = t('你已拒绝');
        break;
        case '3':
          $row[] = t('!n 被列为黑名单', array('!n' => theme('username',$touser)));
        break;
      }
    }
    $rows[] = $row;
    $true = true;
  }
  $v = '<h2 class="x-a-c">'.t('过滤设置：'). l(t('全部'), "user/$user->uid/haoyou/info").' | '.l(t('发出的请求'), "user/$user->uid/haoyou/info/set").' | '.l(t('收到的请求'), "user/$user->uid/haoyou/info/get").'</h2>';
  $v .= theme('table', array(t('时间'), t('主题'), t('状态')), $rows);
  return $v;
}

function cmsns_haoyou_page_info_op($ac){
  global $user;
  $result = db_query('SELECT * FROM {x_haoyou_msg} WHERE id = %d', arg(7));
  $v = db_fetch_object($result);
  if($v->touid == $user->uid && $v->sys == 0 && $v->type == 1){
    switch (arg(5)){
      case 'ok':
        cmsns_haoyou_info_ok(array('touid' => arg(6), 'msgid' => arg(7)));
        return drupal_goto();
      break;
      case 'no':
        db_query('UPDATE {x_haoyou_msg} SET sys = 2, uptime = %d WHERE id = %d', time(), arg(7));
        return drupal_goto();
      break;
      case 'kill':
        if(db_query("INSERT INTO {x_haoyou_to} (uid, touid, gid) VALUES (%d, %d, 1)", $user->uid, arg(6))){
          db_query('UPDATE {x_haoyou_msg} SET sys = 3, uptime = %d WHERE id = %d', time(), arg(7));
          return drupal_goto();
        }
      break;
    }
  }else{
    drupal_not_found();
  }
}

function cmsns_qianbao_page_view($ac){
  $u = _cmsns_qianbao_view($ac->uid);
  $v = '<div class="qianbaoview">'.t('你当前共有现金 !sum', array('!sum' => $u->sum ? $u->sum: 0)).'</div>';
  $v .= drupal_get_form('cmsns_qianbao_to_form', $u);
  return $v;
}

function cmsns_qianbao_to_form(& $form_state, $u){
	$form['value'] = array(
		'#type'=> 'textfield',
		'#title' => t('汇出金额'),
    '#required' => TRUE,
		'#size' => '10',
	);
	$form['touser'] = array(
    '#type'=> 'textfield',
    '#title' => t('汇给'),
    '#size' => 30,
    '#maxlength' => 60,
    '#required' => TRUE,
    '#default_value' => $_GET['user'],
    '#autocomplete_path' => 'user/autocomplete',
	);
	$form['msg'] = array(
		'#type'=> 'textfield',
		'#title' => t('汇款留言'),
    '#description' => t('对方收到的同时，将看到你的留言。60字以内。'),
    '#maxlength' => 128,
		'#size' => '60',
	);
  $form['info'] = array(
  	'#type' => 'value',
  	'#value' => $u
  );
  $form['submit'] = array(
  	'#type' => 'submit',
  	'#value' => t('确认汇款'),
  	'#submit' => array('cmsns_qianbao_to_form_submit'),
  );
  $form['#validate'][] = 'cmsns_qianbao_to_form_validate';
  return $form;
}

function cmsns_qianbao_to_form_validate($form, & $form_state) {
  global $user;
  if (is_numeric($form_state['values']['value']) && $form_state['values']['value'] > 0) {
    $u = $form_state['values']['info'];
    if($u->sum > ($form_state['values']['value']+$form_state['values']['value']*$u->bankhui)){
      $tu = _cmsns_qianbao_user(array('name' => $form_state['values']['touser']));
      if($tu->uid){
        if($tu->uid == $user->uid){
          form_set_error('touser', t('你不能给自己汇款。'));
        }
      }else{
        form_set_error('touser', t('收款人不存在。'));
      }
    }else{
      form_set_error('value', t('汇出金额太大，你的现金不足。'));
    }
  }else{
    form_set_error('value', t('汇款金额不能为空且必须大于0。'));
  }
}

function cmsns_qianbao_to_form_submit($form, & $form_state) {
  global $user;
  $tou = _cmsns_qianbao_user(array('name' => $form_state['values']['touser']));
  $info = $form_state['values']['info'];
  if($t = cmsns_qianbao_addset(array('uid' => $user->uid, 'touid' => $tou->uid, 'value' => $form_state['values']['value'], 'type' => 'zhuanzhang', 'msg' => $form_state['values']['msg']))){
    drupal_set_message(t('你通过 %bank 寄了 %v 元给 !to，%bank 收取手续费 %h（汇率 %hui %），你的钱包里还有现金 %upsum 元。', array('%bank' => $info->bankname, '%v' => $t['value'], '!to' => theme('cmsns_username',$tou), '%h' => $t['hui'], '%hui' => ($info->bankhui*100), '%upsum' => $t['updatesum'])));
  }else{
    form_set_error('errer', t('账务系统例行检修，汇款失败。'));
  }
}

function cmsns_qianbao_page_info($ac){
  global $user;
  $t = '';
  switch (arg(4)){
    case 'add':
      $sql = '(ref = 1 AND uid = '.$user->uid.') OR touid = '.$user->uid;
    break;
    case 'remove':
      $sql = 'ref = 0 AND uid = '.$user->uid;
    break;
    default:
      $sql = 'uid = '.$user->uid.' OR touid = '.$user->uid;
    break;
  }
  $result = pager_query('SELECT uid, touid, type, time, value, msg, tosum, sum, hui, link FROM {x_qianbao_to} WHERE '.$sql.' ORDER BY time DESC', 20, 0);
  $comm = t('汇款留言：');
  while ($a = db_fetch_object($result)) {
    switch ($a->type){
      case 'zhuanzhang':
        if($a->uid == $user->uid){
          $u = _cmsns_qianbao_user(array('uid' => $a->touid));
          $t[][] = t('!t(!i之前)，你给 !n 汇去了 !v 元，手续费 !b(汇率 !h)，当前你的现金总额为：!c 元。!msg', array('!t' => format_date($a->time,'small'), '!i' => format_interval(time() - $a->time), '!n' => theme('cmsns_username',$u), '!v' => $a->value, '!b' => $a->value*$a->hui, '!h' => ($a->hui*100).'%', '!c' => $a->sum, '!msg' => ($a->msg ? $comm.$a->msg: NULL)));
        }else{
          $u = _cmsns_qianbao_user(array('uid' => $a->uid));
          $t[][] = t('!t(!i之前)，!n 给你汇来了 !v 元，当前你的现金总额为：!c 元。!msg', array('!t' => format_date($a->time,'small'), '!i' => format_interval(time() - $a->time), '!n' => theme('cmsns_username',$u), '!v' => $a->value, '!c' => $a->sum, '!msg' => ($a->msg ? $comm.$a->msg: NULL)));
        }
      break;
      case 'user':
        $t[][] = t('!t(!i之前)，你因为 !link，赚取了 !v 元，当前你的现金总额为 !a 元。', array('!t' => format_date($a->time,'small'), '!i' => format_interval(time() - $a->time), '!v' => $a->value, '!a' => $a->sum, '!link' => '<a href="/'.$a->link.'">' .$a->msg. '</a>'));
      break;
      default:
        if($a->value > 0){
          $m = t(' 赚取了 ');
        }else{
          $m = t(' 被扣除了 ');
        }
        $t[][] = t('!t(!i之前)，你因为 !link !v 元，当前你的现金总额为 !a 元。', array('!t' => format_date($a->time,'small'), '!i' => format_interval(time() - $a->time), '!v' => $a->value, '!a' => $a->sum, '!link' => '<a href="/'.$a->link.'">' .$a->msg. '</a>'.$m));
      break;
    }
  };
  drupal_set_title(t('帐务明细'));
  return theme('table', array(t('过滤设置：') .l(t('只看收入'),"user/$user->uid/qianbao/info/add").l(t('只看支出'),"user/$user->uid/qianbao/info/remove").l(t('查看全部'),"user/$user->uid/qianbao/info")), $t ,array('id' => 'qianbaoinfo')).theme('pager',20, 0);
}